#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import "UConfig.h"
#import "UPayInfo.h"
#import "UGameInfo.h"

//SDK基本定义
#define USDK_VERSION_CODE @"100"
#define USDK_VERSION_NAME @"1.0.0"

//消息通知事件Key
#define KEY_EVENT_CODE @"KEY_EVENT_CODE"
#define KEY_DATA @"KEY_DATA"

//消息通知数据Key
#define EXTRA_USER @"EXTRA_USER"
#define EXTRA_ERROR_MESSAGE @"EXTRA_ERROR_MESSAGE"
#define EXTRA_OUT_ORDER_ID @"EXTRA_OUT_ORDER_ID"

//消息通知事件码定义
typedef NS_ENUM(NSInteger,USDK_EVENT_CODE) {
    USDK_LOGIN_SUCCESS = 1,
    USDK_LOGIN_FAILED = 2,
    USDK_PAY_SUCCESS = 3,
    USDK_PAY_FAILED = 4,
    USDK_PAY_CANCEL = 5,
    USDK_ACCOUNT_LOGOUT_SUCCESS = 6,
    USDK_EXIT_GAME_SUCCESS = 7
};

@interface CYouUSDK : NSObject

//（必接）配置SDK参数
+(void)init:(UConfig *)sdkConfig observer:(id)observer eventHandler:(SEL)aSelector;
//（必接）进入登录流程
+(void)invokeLogin;
//（必接）进入支付流程
+(void)invokePayWithPayInfo:(UPayInfo *)payInfo;
//（必接）提交角色信息，进入游戏时调用
+(void)submitGameInfo:(UGameInfo *)gameInfo;
//（选接）退出登录
+(void)logout;
//（选接）退出游戏
+(void)exit:(UGameInfo *)gameInfo;

//AppDelegate相关回调,所有都必须接入
+ (void)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions appDelegate:(NSObject <UIApplicationDelegate>*) delegate callback:(void(^)(id data))finishBlock;
+ (void)applicationWillResignActive:(UIApplication *)application;
+ (void)applicationDidEnterBackground:(UIApplication *)application;
+ (void)applicationWillEnterForeground:(UIApplication *)application;
+ (void)applicationDidBecomeActive:(UIApplication *)application;
+ (void)applicationWillTerminate:(UIApplication *)application;
+ (void)application:(UIApplication *)application didRegisterForRemoteNotificationsWithDeviceToken:(NSData *)deviceToken;
+ (void)application:(UIApplication *)application didFailToRegisterForRemoteNotificationsWithError:(NSError *)error;
+ (UIInterfaceOrientationMask)application:(UIApplication *)application supportedInterfaceOrientationsForWindow:(nullable UIWindow *)window;
+ (void)application:(UIApplication *)application handleOpenURL:(NSURL *)url;
+ (void)application:(UIApplication *)application openURL:(NSURL *)url sourceApplication:(NSString *)sourceApplication annotation:(id)annotation;
+ (void)application:(UIApplication *)app openURL:(NSURL *)url options:(NSDictionary<NSString*, id> *)options;

@end
